#include <cstdio>
#include <string.h>
#include <algorithm>
using namespace std;

#define NMAX 101
#define LMAX 5005
#define ALPHA 26
#define INF 0x3f3f3f3f

int N, M;
char word[NMAX][LMAX];
int next[NMAX][LMAX][ALPHA];
int stack[NMAX][LMAX], size;

void precompute () {

	int len;

	for (int i = 0; i <= N; i++)
        for (int j = 0; j <= 5000; j++)
            memset (next[i][j], INF, sizeof (next[i][j]));

	for (int i = 1; i <= N; i++) {
		len = strlen (word[i]);
		for (int j = len - 1; j >= 0; j--)
			for (int k = 0; k < 26; k++) {
				next[i][j][k] = next[i][j+1][k];
				if (word[i][j+1] == k + 'a') next[i][j][k] = j+1;
			}
	}
}

void solve () {

	int rez = 0;
	char ch;

	size = 1;
	for (; M; M--) {
		scanf ("%c\n", &ch);
	    if (ch == '-') size--;
		else {
			for (int i = 1; i <= N; i++)
				if (stack[i][size] != INF) stack[i][size + 1] = next[i][ stack[i][size] ][ch - 'a'];
				else stack[i][size + 1] = INF;
			size++;
		}

		rez = 0;
		for (int i = 1; i <= N; i++)
			if (stack[i][size] != INF) rez++;

		printf ("%d\n", rez);
	}
}

void readData () {

	scanf ("%d %d\n", &N, &M);
	for (int i = 1; i <= N; i++) {
		word[i][0] = ' ';
		scanf ("%s\n", word[i]+1);
	}
}


int main () {

	freopen ("search.in", "r", stdin);
	freopen ("search.out", "w", stdout);

	readData ();
	precompute ();
	solve ();

	return 0;
}

